RG(1)

NAME
rg - recursively search current directory for lines matching a pattern

SYNOPSIS
rg [OPTIONS] PATTERN [PATH...] rg [OPTIONS] -e PATTERN... [PATH...] rg [OPTIONS] -f PATH... [PATH...] rg [OPTIONS] --files [PATH...] rg [OPTIONS] --type-list rg [OPTIONS] --help rg [OPTIONS] --version

DESCRIPTION
ripgrep (rg) recursively searches your current directory for a regex pattern. By default, ripgrep will respect your .gitignore and automatically skip hidden files/directories and binary files. ripgrep&#8217;s regex engine uses finite automata and guarantees linear time searching. Because of this, features like backreferences and arbitrary lookaround are not supported.

REGEX SYNTAX
ripgrep uses Rust&#8217;s regex engine, which documents its syntax: https://docs.rs/regex/0.2.5/regex/#syntax ripgrep uses byte-oriented regexes, which has some additional documentation: https://docs.rs/regex/0.2.5/regex/bytes/index.html#syntax To a first approximation, ripgrep uses Perl-like regexes without look-around or backreferences. This makes them very similar to the "extended" (ERE) regular expressions supported by egrep, but with a few additional features like Unicode character classes.

POSITIONAL ARGUMENTS

PATTERN
    A regular expression used for searching. To match a pattern beginning with a dash, use the -e/--regexp option.

PATH
    A file or directory to search. Directories are searched recursively. Paths specified expicitly on the command line override glob and ignore rules.

OPTIONS

-A, --after-context NUM
    Show NUM lines after each match. This overrides the --context flag.

-B, --before-context NUM
    Show NUM lines before each match. This overrides the --context flag.

-s, --case-sensitive
    Search case sensitively. This overrides the -i/--ignore-case and -S/--smart-case flags.

--color WHEN
    This flag controls when to use colors. The default setting is auto, which means ripgrep will try to guess when to use colors. For example, if ripgrep is printing to a terminal, then it will use colors, but if it is redirected to a file or a pipe, then it will suppress color output. ripgrep will suppress color output in some other circumstances as well. For example, if the TERM environment variable is not set or set to dumb, then ripgrep will not use colors. The possible values for this flag are:
    never    Colors will never be used.
    auto     The default. ripgrep tries to be smart.
    always   Colors will always be used regardless of where output is sent.
    ansi     Like 'always', but emits ANSI escapes (even in a Windows console).
    When the --vimgrep flag is given to ripgrep, then the default value for the --color flag changes to never.

--colors COLOR_SPEC ...
    This flag specifies color settings for use in the output. This flag may be provided multiple times. Settings are applied iteratively. Colors are limited to one of eight choices: red, blue, green, cyan, magenta, yellow, white and black. Styles are limited to nobold, bold, nointense, intense, nounderline or underline. The format of the flag is {type}:{attribute}:{value}. {type} should be one of path, line, column or match. {attribute} can be fg, bg or style. {value} is either a color (for fg and bg) or a text style. A special format, {type}:none, will clear all color settings for {type}. For example, the following command will change the match color to magenta and the background color for line numbers to yellow:
    rg --colors 'match:fg:magenta' --colors 'line:bg:yellow' foo.
    Extended colors can be used for {value} when the terminal supports ANSI color sequences. These are specified as either x (256-color) or x,x,x (24-bit truecolor) where x is a number between 0 and 255 inclusive. x may be given as a normal decimal number or a hexadecimal number, which is prefixed by 0x. For example, the following command will change the match background color to that represented by the rgb value (0,128,255):
    rg --colors 'match:bg:0,128,255'
    or, equivalently,
    rg --colors 'match:bg:0x0,0x80,0xFF'
    Note that the the intense and nointense style flags will have no effect when used alongside these extended color codes.

--column
    Show column numbers (1-based). This only shows the column numbers for the first match on each line. This does not try to account for Unicode. One byte is equal to one column. This implies --line-number.

-C, --context NUM
    Show NUM lines before and after each match. This is equivalent to providing both the -B/--before-context and -A/--after-context flags with the same value. This overrides both the -B/--before-context and -A/--after-context flags.

--context-separator SEPARATOR
    The string used to separate non-contiguous context lines in the output. Escape sequences like \x7F or \t may be used. The default value is --.

-c, --count
    This flag suppresses normal output and shows the number of lines that match the given patterns for each file searched. Each file containing a match has its path and count printed on each line. Note that this reports the number of lines that match and not the total number of matches. If only one file is given to ripgrep, then only the count is printed if there is a match. The --with-filename flag can be used to force printing the file path in this case.

--debug
    Show debug messages. Please use this when filing a bug report.

--dfa-size-limit NUM+SUFFIX?
    The upper size limit of the regex DFA. The default limit is 10M. This should only be changed on very large regex inputs where the (slower) fallback regex engine may otherwise be used if the limit is reached. The argument accepts the same size suffixes as allowed in with the --max-filesize flag.

-E, --encoding ENCODING
    Specify the text encoding that ripgrep will use on all files searched. The default value is auto, which will cause ripgrep to do a best effort automatic detection of encoding on a per-file basis. Other supported values can be found in the list of labels here: https://encoding.spec.whatwg.org/#concept-encoding-get

-f, --file PATH ...
    Search for patterns from the given file, with one pattern per line. When this flag is used multiple times or in combination with the -e/--regexp flag, then all patterns provided are searched. Empty pattern lines will match all input lines, and the newline is not counted as part of the pattern. A line is printed if and only if it matches at least one of the patterns.

--files
    Print each file that would be searched without actually performing the search. This is useful to determine whether a particular file is being search or not.

-l, --files-with-matches
    Only print the paths with at least one match. This overrides --files-without-match.

--files-without-match
    Only print the paths that contain zero matches. This inverts/negates the --files-with-matches flag. This overrides --files-with-matches.

-F, --fixed-strings
    Treat the pattern as a literal string instead of a regular expression. When this flag is used, special regular expression meta characters such as .(){}*+ do not need to be escaped.

-L, --follow
    When this flag is enabled, ripgrep will follow symbolic links while traversing directories. This is disabled by default. Note that ripgrep will check for symbolic link loops and report errors if it finds one. This flag can be disabled with --no-follow.

-g, --glob GLOB ...
    Include or exclude files and directories for searching that match the given glob. This always overrides any other ignore logic. Multiple glob flags may be used. Globbing rules match .gitignore globs. Precede a glob with a ! to exclude it.

--heading
    This flag prints the file path above clusters of matches from each file instead of printing the file path as a prefix for each matched line. This is the default mode when printing to a terminal. This overrides the --no-heading flag.

--hidden
    Search hidden files and directories. By default, hidden files and directories are skipped. Note that if a hidden file or a directory is whitelisted in an ignore file, then it will be searched even if this flag isn&#8217;t provided. This flag can be disabled with --no-hidden.

--iglob GLOB ...
    Include or exclude files and directories for searching that match the given glob. This always overrides any other ignore logic. Multiple glob flags may be used. Globbing rules match .gitignore globs. Precede a glob with a ! to exclude it. Globs are matched case insensitively.

-i, --ignore-case
    When this flag is provided, the given patterns will be searched case insensitively. The case insensitivity rules used by ripgrep conform to Unicode&#8217;s "simple" case folding rules. This flag overrides -s/--case-sensitive and -S/--smart-case.

--ignore-file PATH ...
    Specifies a path to one or more .gitignore format rules files. These patterns are applied after the patterns found in .gitignore and .ignore are applied and are matched relative to the current working directory. Multiple additional ignore files can be specified by using the --ignore-file flag several times. When specifying multiple ignore files, earlier files have lower precedence than later files. If you are looking for a way to include or exclude files and directories directly on the command line, then used -g instead.

-v, --invert-match
    Invert matching. Show lines that do not match the given patterns.

-n, --line-number
    Show line numbers (1-based). This is enabled by default when searching in a terminal.

--line-number-width NUM
    Left pad line numbers up to NUM width. Space is used as the default padding character. This has no effect if --no-line-number is enabled.

-x, --line-regexp
    Only show matches surrounded by line boundaries. This is equivalent to putting ^...$ around all of the search patterns. In other words, this only prints lines where the entire line participates in a match. This overrides the --word-regexp flag.

-M, --max-columns NUM
    Don&#8217;t print lines longer than this limit in bytes. Longer lines are omitted, and only the number of matches in that line is printed. When this flag is omitted or is set to 0, then it has no effect.

-m, --max-count NUM
    Limit the number of matching lines per file searched to NUM.

--max-filesize NUM+SUFFIX?
    Ignore files larger than NUM in size. This does not apply to directories. The input format accepts suffixes of K, M or G which correspond to kilobytes, megabytes and gigabytes, respectively. If no suffix is provided the input is treated as bytes. Examples: --max-filesize 50K or --max-filesize 80M

--maxdepth NUM
    Limit the depth of directory traversal to NUM levels beyond the paths given. A value of zero only searches the explicitly given paths themselves. For example, rg --maxdepth 0 dir/ is a no-op because dir/ will not be descended into. rg --maxdepth 1 dir/ will search only the direct children of dir.

--mmap
    Search using memory maps when possible. This is enabled by default when ripgrep thinks it will be faster. Memory map searching doesn&#8217;t currently support all options, so if an incompatible option (e.g., --context) is given with --mmap, then memory maps will not be used. Note that ripgrep may abort unexpectedly when --mmap if it searches a file that is simultaneously truncated. This flag overrides --no-mmap.

--no-config
    Never read configuration files. When this flag is present, ripgrep will not respect the RIPGREP_CONFIG_PATH environment variable. If ripgrep ever grows a feature to automatically read configuration files in pre-defined locations, then this flag will also disable that behavior as well.

--no-filename
    Never print the file path with the matched lines. This is the default when ripgrep is explicitly instructed to search one file or stdin. This flag overrides --with-filename.

--no-heading
    Don&#8217;t group matches by each file. If --no-heading is provided in addition to the -H/--with-filename flag, then file paths will be printed as a prefix for every matched line. This is the default mode when not printing to a terminal. This overrides the --heading flag.

--no-ignore
    Don&#8217;t respect ignore files (.gitignore, .ignore, etc.). This implies --no-ignore-parent and --no-ignore-vcs. This flag can be disabled with the --ignore flag.

--no-ignore-parent
    Don&#8217;t respect ignore files (.gitignore, .ignore, etc.) in parent directories. This flag can be disabled with the --ignore-parent flag.

--no-ignore-vcs
    Don&#8217;t respect version control ignore files (.gitignore, etc.). This implies --no-ignore-parent for VCS files. Note that .ignore files will continue to be respected. This flag can be disabled with the --ignore-vcs flag.

-N, --no-line-number
    Suppress line numbers. This is enabled by default when not searching in a terminal.

--no-messages
    Suppress all error messages. This provides the same behavior as redirecting stderr to /dev/null on Unix-like systems. This flag can be disabled with the --messages flag.

--no-mmap
    Never use memory maps, even when they might be faster. This flag overrides --mmap.

-0, --null
    Whenever a file path is printed, follow it with a NUL byte. This includes printing file paths before matches, and when printing a list of matching files such as with --count, --files-with-matches and --files. This option is useful for use with xargs.

-o, --only-matching
    Print only the matched (non-empty) parts of a matching line, with each such part on a separate output line.

--passthru
    Print both matching and non-matching lines. Another way to achieve a similar effect is by modifying your pattern to match the empty string. For example, if you are searching using rg foo then using rg "^|foo" instead will emit every line in every file searched, but only occurrences of foo will be highlighted. This flag enables the same behavior without needing to modify the pattern. This flag conflicts with the --only-matching and --replace flags.

--path-separator SEPARATOR
    Set the path separator to use when printing file paths. This defaults to your platform&#8217;s path separator, which is / on Unix and \ on Windows. This flag is intended for overriding the default when the environment demands it (e.g., cygwin). A path separator is limited to a single byte.

-p, --pretty
    This is a convenience alias for --color always --heading --line-number. This flag is useful when you still want pretty output even if you&#8217;re piping ripgrep to another program or file. For example: rg -p foo | less -R.

-q, --quiet
    Do not print anything to stdout. If a match is found in a file, then ripgrep will stop searching. This is useful when ripgrep is used only for its exit code (which will be an error if no matches are found).

--regex-size-limit NUM+SUFFIX?
    The upper size limit of the compiled regex. The default limit is 10M. The argument accepts the same size suffixes as allowed in the --max-filesize flag.

-e, --regexp PATTERN ...
    A pattern to search for. This option can be provided multiple times, where all patterns given are searched. Lines matching at least one of the provided patterns are printed. This flag can also be used when searching for patterns that start with a dash. For example, to search for the literal -foo, you can use this flag:
    rg -e -foo
    You can also use the special -- delimiter to indicate that no more flags will be provided. Namely, the following is equivalent to the above:
    rg -- -foo

-r, --replace REPLACEMENT_TEXT
    Replace every match with the text given when printing results. Neither this flag nor any other ripgrep flag will modify your files. Capture group indices (e.g., $5) and names (e.g., $foo) are supported in the replacement string. Note that the replacement by default replaces each match, and NOT the entire line. To replace the entire line, you should match the entire line. This flag can be used with the -o/--only-matching flag.

-z, --search-zip
    Search in compressed files. Currently gz, bz2, xz, and lzma files are supported. This option expects the decompression binaries to be available in your PATH. This flag can be disabled with --no-search-zip.

-S, --smart-case
    Searches case insensitively if the pattern is all lowercase. Search case sensitively otherwise. This overrides the -s/--case-sensitive and -i/--ignore-case flags.

--sort-files
    Sort results by file path. Note that this currently disables all parallelism and runs search in a single thread. This flag can be disabled with --no-sort-files.

-a, --text
    Search binary files as if they were text. When this flag is present, ripgrep&#8217;s binary file detection is disabled. This means that when a binary file is searched, its contents may be printed if there is a match. This may cause escape codes to be printed that alter the behavior of your terminal. When binary file detection is enabled it is imperfect. In general, it uses a simple heuristic. If a NUL byte is seen during search, then the file is considered binary and search stops (unless this flag is present). Note that when the -u/--unrestricted flag is provided for a third time, then this flag is automatically enabled. This flag can be disabled with --no-text.

-j, --threads NUM
    The approximate number of threads to use. A value of 0 (which is the default) causes ripgrep to choose the thread count using heuristics.

-t, --type TYPE ...
    Only search files matching TYPE. Multiple type flags may be provided. Use the --type-list flag to list all available types.

--type-add TYPE_SPEC ...
    Add a new glob for a particular file type. Only one glob can be added at a time. Multiple --type-add flags can be provided. Unless --type-clear is used, globs are added to any existing globs defined inside of ripgrep. Note that this MUST be passed to every invocation of ripgrep. Type settings are NOT persisted. Example:
    rg --type-add 'foo:*.foo' -tfoo PATTERN.
    --type-add can also be used to include rules from other types with the special include directive. The include directive permits specifying one or more other type names (separated by a comma) that have been defined and its rules will automatically be imported into the type specified. For example, to create a type called src that matches C++, Python and Markdown files, one can use:
    --type-add 'src:include:cpp,py,md'
    Additional glob rules can still be added to the src type by using the --type-add flag again:
    --type-add 'src:include:cpp,py,md' --type-add 'src:*.foo'
    Note that type names must consist only of Unicode letters or numbers. Punctuation characters are not allowed.

--type-clear TYPE ...
    Clear the file type globs previously defined for TYPE. This only clears the default type definitions that are found inside of ripgrep. Note that this MUST be passed to every invocation of ripgrep. Type settings are NOT persisted.

--type-list
    Show all supported file types and their corresponding globs.

-T, --type-not TYPE ...
    Do not search files matching TYPE. Multiple type-not flags may be provided. Use the --type-list flag to list all available types.

-u, --unrestricted ...
    Reduce the level of "smart" searching. A single -u won&#8217;t respect .gitignore (etc.) files. Two -u flags will additionally search hidden files and directories. Three -u flags will additionally search binary files. -uu is roughly equivalent to grep -r and -uuu is roughly equivalent to grep -a -r.

--vimgrep
    Show results with every match on its own line, including line numbers and column numbers. With this option, a line with more than one match will be printed more than once.

-H, --with-filename
    Display the file path for matches. This is the default when more than one file is searched. If --heading is enabled (the default when printing to a terminal), the file path will be shown above clusters of matches from each file; otherwise, the file name will be shown as a prefix for each matched line. This flag overrides --no-filename.

-w, --word-regexp
    Only show matches surrounded by word boundaries. This is roughly equivalent to putting \b before and after all of the search patterns. This overrides the --line-regexp flag.

EXIT STATUS
If ripgrep finds a match, then the exit status of the program is 0. If no match could be found, then the exit status is non-zero.

CONFIGURATION FILES
ripgrep supports reading configuration files that change ripgrep&#8217;s default behavior. The format of the configuration file is an "rc" style and is very simple. It is defined by two rules:

1.  Every line is a shell argument, after trimming ASCII whitespace.

2.  Lines starting with # (optionally preceded by any amount of ASCII whitespace) are ignored.

ripgrep will look for a single configuration file if and only if the RIPGREP_CONFIG_PATH environment variable is set and is non-empty. ripgrep will parse shell arguments from this file on startup and will behave as if the arguments in this file were prepended to any explicit arguments given to ripgrep on the command line. For example, if your ripgreprc file contained a single line:
--smart-case
then the following command
RIPGREP_CONFIG_PATH=wherever/.ripgreprc rg foo
would behave identically to the following command
rg --smart-case foo
ripgrep also provides a flag, --no-config, that when present will suppress any and all support for configuration. This includes any future support for auto-loading configuration files from pre-determined paths. Conflicts between configuration files and explicit arguments are handled exactly like conflicts in the same command line invocation. That is, this command:
RIPGREP_CONFIG_PATH=wherever/.ripgreprc rg foo --case-sensitive
is exactly equivalent to
rg --smart-case foo --case-sensitive
in which case, the --case-sensitive flag would override the --smart-case flag.

SHELL COMPLETION
Shell completion files are included in the release tarball for Bash, Fish, Zsh and PowerShell. For bash, move rg.bash to $XDG_CONFIG_HOME/bash_completion or /etc/bash_completion.d/. For fish, move rg.fish to $HOME/.config/fish/completions. For zsh, move _rg to one of your $fpath directories.

CAVEATS
ripgrep may abort unexpectedly when using default settings if it searches a file that is simultaneously truncated. This behavior can be avoided by passing the --no-mmap flag which will forcefully disable the use of memory maps in all cases.

VERSION
0.8.1 -SIMD -AVX

HOMEPAGE
https://github.com/BurntSushi/ripgrep Please report bugs and feature requests in the issue tracker.

AUTHORS
Andrew Gallant <jamslam@gmail.com>